Unit DE84RJ_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure DE84RJ(F :Proc_F_DE; X :Real; var Y :Array of Real;
                var A :Array of Real; M :Integer; DEL :Real;
                var R1 :Array of Real; var R2 :Array of Real);
implementation

procedure DE84RJ(F :Proc_F_DE; X :Real; var Y :Array of Real;
                var A :Array of Real; M :Integer; DEL :Real;
                var R1 :Array of Real; var R2 :Array of Real);
var
I,J :Integer;
D,T,W :Real;
label
_10,_20;
begin
for J:=1 to M do
 begin
  D := DEL;
  T := Y[J-1];
  if ( T+D  = T )
   then D := D*T;
  Y[J-1] := T - D;
  W := Y[J-1];
  F (X,Y,R1,M);
  Y[J-1] := T + D;
  F (X,Y,R2,M);
  W := Y[J-1]-W;
  Y[J-1] := T;
  for I:=1 to M do
   begin
    A[(I-1)+(J-1)*M] := (R2[I-1] - R1[I-1])/W;
_10:
   end;
_20:
 end;
end;

end.
